'use strict';

var DSRRecord = require('./Record');
var Passport = require('../passport/Passport');
var createStatsEmitter = require('request-stats');

module.exports = createDsrMiddleware;

function createDsrMiddleware() {
  return function dsrMiddleware(req, res, next) {
    if (!req.headers[Passport.HEADER_NAME]) {
      return next();
    }

    var startTime = Date.now();
    createStatsEmitter(req, res)
      .once('complete', function (stats) {
        var record = new DSRRecord(req);
        record.setHttpStats(stats);
        record.setStartTime(startTime);
        record.log();
      });

    next();
  };
}
